#!/bin/sh

rm -f EttinOS.img
mkdir -p bin

cd src/
if [ "$1" = "-1440" ]
    then nasm BOOT.ASM -d F1440 -f bin -o ../bin/BOOT.BIN
    else nasm BOOT.ASM -f bin -o ../bin/BOOT.BIN
fi
nasm SYSTEM.ASM -f bin -o ../bin/SYSTEM.BIN
nasm HELLO.ASM -f bin -o ../bin/HELLO.BIN

cd ..
if [ "$1" = "-1440" ]
    then mkfs.fat -C EttinOS.img 1440 1>/dev/null
    else mkfs.fat -C EttinOS.img 360 1>/dev/null
fi

if which rw > /dev/null 2>&1
    then rw -i bin/BOOT.BIN -o EttinOS.img -b 512 -c 1x
    else dd if=bin/BOOT.BIN of=EttinOS.img conv=notrunc bs=512 count=1 1>/dev/null
fi
mcopy -i EttinOS.img bin/SYSTEM.BIN ::
mcopy -i EttinOS.img bin/HELLO.BIN ::
mcopy -i EttinOS.img README.MD ::
mcopy -i EttinOS.img LICENSE.MD ::
